<script lang="ts">
	import queryString from "query-string"
	import { getContext } from "svelte"
	import { browser } from "$app/env"
	import { goto } from "$app/navigation"
	import { page, session } from "$app/stores"
	import type { DataPackage, Project } from "$lib/storage"
	import ProjectLoader from "$lib/components/ProjectLoader.svelte"
	import ProjectSelector from "$lib/components/ProjectSelector.svelte"
	import DataPackageForm from "$lib/components/DataPackageForm.svelte"
	import MultilineLoadIndicator from "$lib/components/MultilineLoadIndicator.svelte"
	import { userProfile } from "$lib/stores"
	import { AUTH_CONTEXT_KEY } from "$lib/constants"

	$: project = $page.query.get("project")

	let datapackage: DataPackage = null
	let errorMessage = null
	let fetchError
	let storageAdapter

	let selectedProject: Project | null = null
	let filteredFiles: Array<string> = []
	let previousFiles: Array<string> = []
	let removedFiles: Array<string> = []

	const { gotoLoginIfAnonymous, tokens } = getContext(AUTH_CONTEXT_KEY)
	gotoLoginIfAnonymous($page)
	$: if (browser && $tokens && $userProfile) {
		fetchInitialData($session, $tokens, $userProfile)
	}

	async function fetchInitialData(session, tokens, userProfile) {
		const GitLabStorageAdapter = (await import("$lib/infrastructure/storage-adapter/gitlab")).default
		storageAdapter = GitLabStorageAdapter.create(session.config, tokens, userProfile)
		// Fetch data package to edit
		if (project) {
			try {
				datapackage = await storageAdapter.fetchDataPackage(project)
				filteredFiles = datapackage.resources.map((resource) => resource.path).filter(Boolean)
				previousFiles = [...filteredFiles]
				selectedProject = await storageAdapter.fetchProject(project)
			} catch (error) {
				console.error(error)
				fetchError = "Could not load data package"
			}
		} else {
			fetchError = "Query string parameter 'project' is missing"
		}
	}

	async function handleSubmit(event) {
		if (selectedProject === null || storageAdapter === null) {
			return
		}
		const formData = event.detail
		let dataPackageUpdated
		try {
			dataPackageUpdated = await storageAdapter.editDataPackage(
				selectedProject,
				formData,
				filteredFiles,
				previousFiles,
				removedFiles
			)
		} catch (error) {
			console.error(error)
			fetchError = "Could not update data package"
		}
		if (dataPackageUpdated) {
			goto(
				queryString.stringifyUrl({
					url: "/data-packages/view",
					query: {
						project: (selectedProject as Project).name,
					},
				})
			)
		}
	}
</script>

<nav aria-label="breadcrumb" class="mb-8">
	<ul class="breadcrumb p-2 rounded bg-gray-100">
		<li class="breadcrumb-item"><a href="/data-packages">Data Packages</a></li>
		<li class="breadcrumb-item" aria-current="page">Edit</li>
	</ul>
</nav>

{#if fetchError}
	<p>{fetchError}</p>
{:else if selectedProject}
	<h1>
		<a href={selectedProject.url} rel="external" target="_blank">{selectedProject.name}</a>
	</h1>

	{#if storageAdapter && datapackage}
		<DataPackageForm
			editDataPackage
			{errorMessage}
			{selectedProject}
			name={datapackage.name}
			description={datapackage.description}
			bind:filteredFiles
			{previousFiles}
			bind:removedFiles
			on:submit={handleSubmit}
			previousDataPackage={datapackage}
		>
			<ProjectLoader {storageAdapter} let:projects>
				<ProjectSelector bind:selected={selectedProject} {projects} enableUnselect />
			</ProjectLoader>
		</DataPackageForm>
	{/if}
{:else}
	<MultilineLoadIndicator />
{/if}
